<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'pkid',
    label: '编号',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelName',
    label: '模型名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelCode',
    label: '模型编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelGrading',
    label: '模型粒度',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelCrime',
    label: '模型涉罪类型',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelComment',
    label: '模型描述',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelScore',
    label: '触发模型条件所需分数',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelType',
    label: '模型实现方式',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'modelFormula',
    label: '模型公式 ',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '模型状态',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

